; -*- lisp -*-
;
;  Variation of PDK "Example program #1": count players' units
;

(load "stdlib.ly")

(define (makelist n e)
  (let (result)
    (while (> n 0)
      (setq result (cons e result))
      (setq n (- n 1)))
    result
    )
  )

(setq *ships*    (makelist 12 0))
(setq *planets*  (makelist 12 0))
(setq *bases*    (makelist 12 0))

(foreach ix (all-ships)
  (let ((o (ship-owner ix)))
    (setf (nth o *ships*) (+ 1 (nth o *ships*)))
    )
  )

(foreach ix (all-planets)
  (let ((o (planet-owner ix)))
    (setf (nth o *planets*) (+ 1 (nth o *planets*)))
    (if (base-exists-p ix)
        (setf (nth o *bases*) (+ 1 (nth o *bases*)))
      )
    )
  )

(map-range 1 11
  (lambda (race)
    (print-string (concat "Player " (print-to-string race)
                          " has:" newline
                          "  " (print-to-string (nth race *ships*)) " ships" newline
                          "  " (print-to-string (nth race *planets*)) " planets" newline
                          "  " (print-to-string (nth race *bases*)) " starbases" newline)
                  )
    )
  )
